<?php
/**
 * NextBestNetwork - Tweaked version of Vector, using Twitter Bootstrap.

 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * http://www.gnu.org/copyleft/gpl.html
 *
 * @file
 * @ingroup Skins
 */

/**
 * Skin subclass for NextBestNetwork
 * @ingroup Skins
 */
class SkinNextBestNetwork extends SkinTemplate {
	public $skinname = 'nextbestnetwork';
	public $stylename = 'NextBestNetwork';
	public $template = 'NextBestNetworkTemplate';
	public $useHeadElement = true;
	/**
	 * @var Config
	 */
	private $nextbestnetworkConfig;
	private $responsiveMode = false;

	public function __construct( $options ) {
		$this->nextbestnetworkConfig = \MediaWiki\MediaWikiServices::getInstance()->getConfigFactory()
			->makeConfig( 'nextbestnetwork' );
		$options['bodyOnly'] = true;
		parent::__construct( $options );
	}


	/**
	 * Initializes output page and sets up skin-specific parameters
	 * @param OutputPage $out Object to initialize
	 */
	public function initPage( OutputPage $out ) {
		parent::initPage( $out );

		$out->addMeta( 'viewport', 'width=device-width, initial-scale=1' );
		$out->addModules( 'skins.nextbestnetwork.messages' );

		// load externally defined script module
		if( $this->nextbestnetworkConfig->get( 'NextBestNetworkSkinCustomScriptModule' ) ) {
			$out->addModules( $this->nextbestnetworkConfig->get( 'NextBestNetworkSkinCustomScriptModule' ) );

		// or: load modules defined by nextbestnetwork
		} else {
			if( !$this->nextbestnetworkConfig->get( 'NextBestNetworkSkinUseCustomFiles' ) ) {
				$out->addModules( 'skins.nextbestnetwork.scripts' );
			} else {
				$out->addModules( 'skins.nextbestnetwork.custom.scripts' );
			}
		}
	}
	

	/**
	 * Override to pass our Config instance to it
	 * @param string $classname
	 * @param bool|string $repository
	 * @param bool|string $cache_dir
	 * @return QuickTemplate
	 */
	public function setupTemplate( $classname, $repository = false, $cache_dir = false ) {
		return new $classname( $this->nextbestnetworkConfig );
	}


	/**
	 * Whether the logo should be preloaded with an HTTP link header or not
	 * @since 1.29
	 * @return bool
	 */
	public function shouldPreloadLogo() {
		return true;
	}
}
